import React, {useState, useEffect, useRef} from 'react';
import List from '@mui/material/List';
import ListItem from '@mui/material/ListItem';
import ListItemText from '@mui/material/ListItemText';
import ListItemAvatar from '@mui/material/ListItemAvatar';
import Box from '@mui/material/Box';

import {Link} from 'react-router-dom'

import { FloatBtn, ChatAvatar } from "../components"
import { connect }  from 'react-redux'


const Chat = ({ chat, currChat }) => {

  const [msgText, setMsgText] = useState( chat.messages && chat.messages[0]?.text || 'нема')

  // const {_id, title, owner, members, messages} = chat
  // const { text, owner: msgOwner, media, createdAt } = messages

  useEffect(() => {
    setMsgText( chat.messages && chat.messages[0]?.text || '...')
  }, [chat])

  return (
    <Link 
      style={{ textDecoration: 'none' }}
      to={`/main/${chat._id}`}
      >
     
      <div
        className={`chatItem ${currChat ? "selectedChat" : "notSelectedChat"} `}
        >
        <div className={"chatAvatar"}>
          <ChatAvatar chat={chat} />
        </div>   

        <div className={"chatBody"}>

          <div className={"chatTitle"}>

            <div className={"chatName"}>
              {chat.title} 
            </div> 

            <div className={"chatStatus"}>
      
            </div> 
          </div> 

          <div className={"chatSubTitle"}>
            {msgText}
          </div> 

        </div>
              
      </div>
    </Link>
  )
}

const ChatList = ({ chats=[], currChatId }) => {

  // const [chatsInput, setChats] = useState(chats)
  // useEffect(() => {
  //   setChats(chats)
  // }, [chats])

  return (
      <List        
        sx={{ width: '100%', bgcolor: 'background.paper', position: 'relative', zIndex: 2, }}
        >
          <div>
            <Box sx={{  position: 'fixed', top: '90%', left: '25%', zIndex: 10}} >
              <FloatBtn />
            </Box>
              {chats.map(chat =>          
                    <Chat key={chat._id} chat={chat} currChat={currChatId === chat._id} /> 
              )}  
          </div>  
        </List>

    
      
  )
}
export const CChatList = connect( state => ({ chats: Object.values(state.chats).filter(el => !!el._id)}))(ChatList)


{/* <div class="ListItem Chat chat-item-clickable private no-selection has-ripple" style="top: 0px;">
  <div class="ListItem-button" role="button" tabindex="0">
    <div class="status">
      <div class="Avatar size-large color-bg-8 saved-messages">
        <i class="icon-avatar-saved-messages"></i>
      </div>
    </div>
  <div class="info">
    <div class="title">
      <h3>Saved Messages</h3>
      <div class="LastMessageMeta">
        <div class="MessageOutgoingStatus">
          <div class="Transition reveal">
            <div class="Transition__slide--active">
              <i class="icon-message-succeeded"></i>
            </div>
          </div>
        </div>
        <span class="time">Mon</span>
      </div>
    </div>
    <div class="subtitle">
      <p class="last-message" dir="ltr">https://dolgvol.github.io/ToDoListProd/</p>
      <div class="Badge-transition open shown">
        <div class="Badge pinned">
          <i class="icon-pinned-chat"></i>
        </div>
      </div>
    </div>
  </div>
  <div class="ripple-container"></div>
</div>
</div> */}